<?php
// $Id: field_textarea.inc,v 1.4 2004/02/20 17:21:24 JonBob Exp $

function flexinode_field_textarea_form($field, &$node, $error) {
  $fieldname = "flexinode_". $field->field_id;
  return form_textarea(t($field->label), $fieldname, isset($node->$fieldname) ? $node->$fieldname : $field->default_value, 60, $field->rows, t($field->description) . ' ' . theme('error', $error[$fieldname]));
}

function flexinode_field_textarea_db_select($field) {
  $fieldname = "flexinode_". $field->field_id;
  return $fieldname .".textual_data AS ". $fieldname;
}

function flexinode_field_textarea_insert($field, $node) {
  $fieldname = "flexinode_". $field->field_id;
  db_query("INSERT INTO {flexinode_data} (nid, field_id, textual_data) VALUES (%d, %d, '%s')", $node->nid, $field->field_id, $node->$fieldname);
}

function flexinode_field_textarea_format($field, $node, $brief = 0) {
  if (!$brief) {
    $fieldname = "flexinode_". $field->field_id;
    return check_output($node->$fieldname);
  }
}

function flexinode_field_textarea_config($field, $edit) {
  $form .= form_textfield(t("Default value"), "default_value", $edit["default_value"], 60, 128);
  $form .= form_textfield(t("Lines"), "rows", $edit["rows"] ? $edit["rows"] : 5, 10, 10, t("How large the text area will be."));
  return $form;
}


/**
 * @addtogroup themeable
 * @{
 */

/**
 * Format a text area for display in a node.
 *
 * @param field_id
 *   Which field is being displayed (useful when overriding this function
 *   if you want to style one particular field differently).
 * @param label
 *   The label for the field as displayed on the node form.
 * @param value
 *   The value that the user entered for the field.
 * @param formatted_value
 *   The value that the user entered for the field as pre-formatted by the module.
 */
function theme_flexinode_textarea($field_id, $label, $value, $formatted_value) {
  return theme("form_element", $label, $formatted_value);
}

/** @} End of addtogroup themeable */

?>